/* -------------------------------------------------------------------------- */
/*                                                                            */
/* [iemsi_view.h]               Display IEMSI Server Info                     */
/*                                                                            */
/* -------------------------------------------------------------------------- */
/*                                                                            */
/* Copyright (c) 1997 by Lars Doelle                                          */
/*                                                                            */
/* This file is part of Kom - a serial line terminal for KDE                  */
/*                                                                            */
/* The whole program is available under the GNU Public Software Licence.      */
/* See COPYING, the documenation, or <http://www.gnu.org> for details.        */
/*                                                                            */
/* -------------------------------------------------------------------------- */

#ifndef IEMSI_VIEW_H
#define IEMSI_VIEW_H

#include <time.h>
#include <qwidget.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qpushbt.h>
#include <qgrpbox.h>
#include <qpalette.h>

#include "iemsi.h"

class IemsiView : public QWidget
{ Q_OBJECT

public:
  IemsiView(IemsiServerInfo* isi, int autoclose = 0);
  ~IemsiView();

private:

void addLine(int row, char* l, char* r);

  QPalette     pal;
  QPushButton* CloseB;

  QGroupBox*   f0;
  QBoxLayout*  v0;
  QGridLayout* v1;

private slots:
  void quit();

};

#endif
